<!doctype html>
<html>
<head>
    <title>Socket.IO chat</title>
    <!-- styles -->
    <link rel="stylesheet" type="text/css" href="/css/styles.css">
    <!-- scripts -->
    <script src="https://code.jquery.com/jquery-latest.min.js"></script>

</head>
<body>
    <section id="wrapper">
        <div id="usernameWrap">
            <p id="usernameError"></p>
            <form id="setUsername">
                <input class="message" id="username" placeholder="Enter your Username"/>
                <input class="button" type="submit" value="JOIN CHAT"/>
            </form>
        </div>
    </section>

    <section id="chatWrapper">
        <div class="disconnect-block">
            <input id="logout" type="button" class="disconnect" value="X">
        </div>
        <div class="container-msg">
            <ul id="chat"></ul>
        </div>
        <form id="send-message">
            <input class="message" type="text" id="message" placeholder="Type a message" autocomplete="off" />
            <input class="button" type="submit" value="ENVOYER"/>
        </form>
    </section>
    
    <!-- script -->
<script src="/socket.io/socket.io.js"></script>
<script>
    let socket =io.connect();

    //page connection
    var $usernameForm = $('#setUsername');
    var $usernameError = $('#usernameError');
    //page chat
    var $username = $('#username');
    var $messageForm = $('#send-message');
    var $messageBox = $('#message');
    var $chat = $('#chat');
    var $currentUser;

    $('#chatWrapper').hide();
    
    /* setting username */
    $usernameForm.submit(function(e){
        e.preventDefault();
        socket.emit('new user',$username.val(),function(data){
            if(data){
                $('#usernameWrap').hide();
                $('#chatWrapper').show();
            } else{
                $usernameError.html('Username is already Taken!');
            }
        });
        $currentUser = $username.val();
        console.log('user : ', $currentUser)
        $username.val('');
    });
    
    
    // sending messages
    $messageForm.submit(function(e){
        e.preventDefault();
        socket.emit('send message',$messageBox.val());
        console.log('msg :', $messageBox.val())
        $messageBox.val('');
    });
    

    // receive msg
    socket.on('new message',function(data){
        if(data.username === $currentUser){
            data.colorClass = "msgL"
            console.log(data.colorClass)
            $chat.append('<div class="floatleft"><li class="' + data.colorClass + '"><b>' + data.username + '</b> : ' + data.message + "<br/></li></div></br>")
            } else{
                data.colorClass = "msgR"
                $chat.append('<div class="floatright"><li class="' + data.colorClass + '"><b>' + data.username + '</b> : ' + data.message + "<br/></li></div></br>")
                }
    });
          
    
    
    // disconnection
    let quit = document.getElementById('logout').addEventListener("click", function(event){
        event.preventDefault()
        console.log('logout')
        socket.disconnect()
        window.location.replace("/");
    });

</script>
<!-- end script -->

</body>
</html>